Index: /stable/HeuristicLab 3.3.sln
===================================================================
--- /stable/HeuristicLab 3.3.sln	(revision 14200)
+++ /stable/HeuristicLab 3.3.sln	(revision 14201)
@@ -1,6 +1,6 @@
 ﻿
 Microsoft Visual Studio Solution File, Format Version 12.00
-# Visual Studio 2013
-VisualStudioVersion = 12.0.40629.0
+# Visual Studio 14
+VisualStudioVersion = 14.0.23107.0
 MinimumVisualStudioVersion = 10.0.40219.1
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{96396439-A764-4022-A8D2-BE021449B8D1}"
@@ -17,5 +17,4 @@
 		{E1D6C801-892A-406A-B606-F158E36DD3C3} = {E1D6C801-892A-406A-B606-F158E36DD3C3}
 		{730A9104-D4D1-4360-966B-E49B7571DDA3} = {730A9104-D4D1-4360-966B-E49B7571DDA3}
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC} = {71CDE004-C50F-48DF-858E-AB0AAA3537BC}
 		{DBFD7205-61AF-40EF-8776-3052DEF91CF3} = {DBFD7205-61AF-40EF-8776-3052DEF91CF3}
 		{315BDA09-3F4F-49B3-9790-B37CFC1C5750} = {315BDA09-3F4F-49B3-9790-B37CFC1C5750}
@@ -41,5 +40,4 @@
 		{D58A232D-04BA-4186-B73E-0EC86FD31ABE} = {D58A232D-04BA-4186-B73E-0EC86FD31ABE}
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6} = {6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE} = {0C67A033-F6D9-4237-B3CA-C033A44706BE}
 		{72232235-B6CF-4E6C-B086-9E9E11AA0717} = {72232235-B6CF-4E6C-B086-9E9E11AA0717}
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1} = {0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}
@@ -62,5 +60,4 @@
 		{78763A4E-E163-48C2-98EB-709760D06F25} = {78763A4E-E163-48C2-98EB-709760D06F25}
 		{94C7714E-29D4-4D6D-B213-2C18D627AB75} = {94C7714E-29D4-4D6D-B213-2C18D627AB75}
-		{5E516C4F-9935-437F-8B15-ECEF4451744E} = {5E516C4F-9935-437F-8B15-ECEF4451744E}
 		{A51DA44F-CB35-4F6F-99F5-2A2E904AB93B} = {A51DA44F-CB35-4F6F-99F5-2A2E904AB93B}
 		{2C36CD4F-E5F5-43A4-801A-201EA895FE17} = {2C36CD4F-E5F5-43A4-801A-201EA895FE17}
@@ -88,5 +85,4 @@
 		{3C906172-E044-4DF0-B4FD-AA21192D5D3E} = {3C906172-E044-4DF0-B4FD-AA21192D5D3E}
 		{DC3D7072-7999-4719-B65D-3997744D5DC1} = {DC3D7072-7999-4719-B65D-3997744D5DC1}
-		{7FC70D74-1813-48B7-9CE5-0BD913457579} = {7FC70D74-1813-48B7-9CE5-0BD913457579}
 		{20831A74-D18F-42D9-A667-1CE3AF53DF93} = {20831A74-D18F-42D9-A667-1CE3AF53DF93}
 		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E} = {F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}
@@ -105,5 +101,4 @@
 		{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4} = {F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}
 		{FE856595-64CD-46DA-9CD2-FFF3E6B0D4F2} = {FE856595-64CD-46DA-9CD2-FFF3E6B0D4F2}
-		{9A04599C-D608-4240-8DA6-D41F51C515A3} = {9A04599C-D608-4240-8DA6-D41F51C515A3}
 		{73857A9C-9706-4B72-8D9C-210B5B6A5691} = {73857A9C-9706-4B72-8D9C-210B5B6A5691}
 		{F409DD9E-1E9C-4EB1-AA3A-9F6E987C6E58} = {F409DD9E-1E9C-4EB1-AA3A-9F6E987C6E58}
@@ -113,5 +108,4 @@
 		{8C426FA3-6614-412C-B669-BCE58DB9710E} = {8C426FA3-6614-412C-B669-BCE58DB9710E}
 		{068C70A7-8CAF-4AB6-8721-4564D62292BC} = {068C70A7-8CAF-4AB6-8721-4564D62292BC}
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A} = {3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}
 		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3} = {64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}
 		{5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8} = {5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8}
@@ -274,8 +268,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4", "HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views\3.4\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj", "{423BD94F-963A-438E-BA45-3BB3D61CD03B}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ArtificialAnt-3.4", "HeuristicLab.Problems.ArtificialAnt\3.4\HeuristicLab.Problems.ArtificialAnt-3.4.csproj", "{0C67A033-F6D9-4237-B3CA-C033A44706BE}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ArtificialAnt.Views-3.4", "HeuristicLab.Problems.ArtificialAnt.Views\3.4\HeuristicLab.Problems.ArtificialAnt.Views-3.4.csproj", "{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis-3.4", "HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj", "{DF87C13E-A889-46FF-8153-66DCAA8C5674}"
 EndProject
@@ -357,8 +347,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.OKB.Views-3.3", "HeuristicLab.Clients.OKB.Views\3.3\HeuristicLab.Clients.OKB.Views-3.3.csproj", "{399EBB6E-37A1-4AE4-B8CD-0D461FF286A3}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.LawnMower-3.3", "HeuristicLab.Problems.LawnMower\3.3\HeuristicLab.Problems.LawnMower-3.3.csproj", "{9A04599C-D608-4240-8DA6-D41F51C515A3}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.LawnMower.Views-3.3", "HeuristicLab.Problems.LawnMower.Views\3.3\HeuristicLab.Problems.LawnMower.Views-3.3.csproj", "{71CDE004-C50F-48DF-858E-AB0AAA3537BC}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.ScatterSearch-3.3", "HeuristicLab.Algorithms.ScatterSearch\3.3\HeuristicLab.Algorithms.ScatterSearch-3.3.csproj", "{5FEE5DB4-7FD9-4CBD-BEC2-3FEE17B31A94}"
@@ -388,6 +374,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ParallelEngine.Views-3.3", "HeuristicLab.ParallelEngine.Views\3.3\HeuristicLab.ParallelEngine.Views-3.3.csproj", "{D34A7620-3E23-40D9-8647-637BE901F271}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.CMAEvolutionStrategy-3.3", "HeuristicLab.Algorithms.CMAEvolutionStrategy\3.3\HeuristicLab.Algorithms.CMAEvolutionStrategy-3.3.csproj", "{5E516C4F-9935-437F-8B15-ECEF4451744E}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.Trading-3.4", "HeuristicLab.Problems.DataAnalysis.Trading\3.4\HeuristicLab.Problems.DataAnalysis.Trading-3.4.csproj", "{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}"
@@ -1147,28 +1131,4 @@
 		{423BD94F-963A-438E-BA45-3BB3D61CD03B}.Release|x86.ActiveCfg = Release|x86
 		{423BD94F-963A-438E-BA45-3BB3D61CD03B}.Release|x86.Build.0 = Release|x86
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Debug|x64.ActiveCfg = Debug|x64
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Debug|x64.Build.0 = Debug|x64
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Debug|x86.ActiveCfg = Debug|x86
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Debug|x86.Build.0 = Debug|x86
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Release|Any CPU.Build.0 = Release|Any CPU
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Release|x64.ActiveCfg = Release|x64
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Release|x64.Build.0 = Release|x64
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Release|x86.ActiveCfg = Release|x86
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE}.Release|x86.Build.0 = Release|x86
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Debug|x64.ActiveCfg = Debug|x64
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Debug|x64.Build.0 = Debug|x64
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Debug|x86.ActiveCfg = Debug|x86
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Debug|x86.Build.0 = Debug|x86
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Release|Any CPU.Build.0 = Release|Any CPU
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Release|x64.ActiveCfg = Release|x64
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Release|x64.Build.0 = Release|x64
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Release|x86.ActiveCfg = Release|x86
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}.Release|x86.Build.0 = Release|x86
 		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1651,28 +1611,4 @@
 		{399EBB6E-37A1-4AE4-B8CD-0D461FF286A3}.Release|x86.ActiveCfg = Release|x86
 		{399EBB6E-37A1-4AE4-B8CD-0D461FF286A3}.Release|x86.Build.0 = Release|x86
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Debug|x64.ActiveCfg = Debug|x64
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Debug|x64.Build.0 = Debug|x64
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Debug|x86.ActiveCfg = Debug|x86
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Debug|x86.Build.0 = Debug|x86
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Release|Any CPU.Build.0 = Release|Any CPU
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Release|x64.ActiveCfg = Release|x64
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Release|x64.Build.0 = Release|x64
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Release|x86.ActiveCfg = Release|x86
-		{9A04599C-D608-4240-8DA6-D41F51C515A3}.Release|x86.Build.0 = Release|x86
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Debug|x64.ActiveCfg = Debug|x64
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Debug|x64.Build.0 = Debug|x64
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Debug|x86.ActiveCfg = Debug|x86
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Debug|x86.Build.0 = Debug|x86
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Release|Any CPU.Build.0 = Release|Any CPU
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Release|x64.ActiveCfg = Release|x64
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Release|x64.Build.0 = Release|x64
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Release|x86.ActiveCfg = Release|x86
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC}.Release|x86.Build.0 = Release|x86
 		{5FEE5DB4-7FD9-4CBD-BEC2-3FEE17B31A94}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{5FEE5DB4-7FD9-4CBD-BEC2-3FEE17B31A94}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1819,16 +1755,4 @@
 		{D34A7620-3E23-40D9-8647-637BE901F271}.Release|x86.ActiveCfg = Release|x86
 		{D34A7620-3E23-40D9-8647-637BE901F271}.Release|x86.Build.0 = Release|x86
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Debug|x64.ActiveCfg = Debug|x64
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Debug|x64.Build.0 = Debug|x64
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Debug|x86.ActiveCfg = Debug|x86
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Debug|x86.Build.0 = Debug|x86
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Release|Any CPU.Build.0 = Release|Any CPU
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Release|x64.ActiveCfg = Release|x64
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Release|x64.Build.0 = Release|x64
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Release|x86.ActiveCfg = Release|x86
-		{5E516C4F-9935-437F-8B15-ECEF4451744E}.Release|x86.Build.0 = Release|x86
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2267,11 +2191,3 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(NestedProjects) = preSolution
-		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-		{9A04599C-D608-4240-8DA6-D41F51C515A3} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-		{71CDE004-C50F-48DF-858E-AB0AAA3537BC} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-		{5E516C4F-9935-437F-8B15-ECEF4451744E} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-		{7FC70D74-1813-48B7-9CE5-0BD913457579} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-	EndGlobalSection
 EndGlobal