Index: /stable/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 14210)
+++ /stable/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 14211)
@@ -170,5 +170,7 @@
     <Compile Include="StatusCommons.cs" />
     <Compile Include="WcfService.cs" />
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
@@ -189,7 +191,7 @@
 set SolutionDir=$(SolutionDir)
 set Outdir=$(Outdir)
+set TargetDir=$(TargetDir)
 set Platform=$(PlatformName)
 set Configuration=$(ConfigurationName)
-set TargetDir=$(ProjectDir)
 
 call "$(SolutionDir)MergeConfigs.cmd"</PostBuildEvent>
Index: /stable/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 14210)
+++ /stable/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 14211)
@@ -150,4 +150,6 @@
     <EmbeddedResource Include="Documents\ALPSGA_TSP.hl" />
     <EmbeddedResource Include="Documents\GA_BPP.hl" />
+    <EmbeddedResource Include="Documents\OSES_Griewank.hl" />
+    <EmbeddedResource Include="Documents\SGP_Robocode.hl" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="OptimizerSingleDocumentMainForm.cs">
Index: /stable/HeuristicLab.Optimizer/3.3/StartPage.cs
===================================================================
--- /stable/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 14210)
+++ /stable/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 14211)
@@ -133,7 +133,7 @@
 
     private void FillGroupLookup() {
-      var standardProblems = new List<string> { "ALPSGA_TSP", "ES_Griewank", "GA_Grouping", "GA_TSP", "GA_VRP", "GE_ArtificialAnt",
+      var standardProblems = new List<string> { "ALPSGA_TSP", "ES_Griewank", "OSES_Griewank", "GA_Grouping", "GA_TSP", "GA_VRP", "GE_ArtificialAnt",
                 "IslandGA_TSP", "LS_Knapsack", "PSO_Schwefel", "RAPGA_JSSP",
-                "SA_Rastrigin", "SGP_SantaFe","GP_Multiplexer", "SS_VRP", "TS_TSP", "TS_VRP", "VNS_OP", "VNS_TSP", "GA_BPP"
+                "SA_Rastrigin", "SGP_SantaFe", "GP_Multiplexer", "SGP_Robocode", "SS_VRP", "TS_TSP", "TS_VRP", "VNS_OP", "VNS_TSP", "GA_BPP"
         };
       groupLookup[standardProblemsGroup] = standardProblems;
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/DeepCloneableCloningTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/DeepCloneableCloningTest.cs	(revision 14210)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/DeepCloneableCloningTest.cs	(revision 14211)
@@ -53,4 +53,6 @@
       foreach (var symbolType in ApplicationManager.Manager.GetTypes(typeof(HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Symbol)))
         excludedTypes.Add(symbolType);
+      // SimpleSymbol is a non-discoverable type and thus needs to be added manually
+      excludedTypes.Add(typeof(HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.SimpleSymbol));
       foreach (var grammarType in ApplicationManager.Manager.GetTypes(typeof(HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.SymbolicExpressionGrammarBase)))
         excludedTypes.Add(grammarType);
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPRobocodeSampleTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPRobocodeSampleTest.cs	(revision 14210)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPRobocodeSampleTest.cs	(revision 14211)
@@ -23,4 +23,5 @@
 using System.Linq;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Data;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Persistence.Default.Xml;
@@ -49,10 +50,12 @@
 
       #region Problem Configuration
-      Problem antProblem = new Problem();
+      Problem robocodeProblem = new Problem();
+      if (!robocodeProblem.Enemies.CheckedItems.Any())
+        robocodeProblem.Enemies.Add(new StringValue("sample.Crazy"));
       #endregion
       #region Algorithm Configuration
       ga.Name = "Genetic Programming - Robocode Java Source";
       ga.Description = "A standard genetic programming algorithm to evolve the java source code for a robocode bot (see http://robocode.sourceforge.net/). An installation of Java SE Developmen Kit (JDK) >= 1.6 is necessary to run this sample.";
-      ga.Problem = antProblem;
+      ga.Problem = robocodeProblem;
       SamplesUtils.ConfigureGeneticAlgorithmParameters<TournamentSelector, SubtreeCrossover, MultiSymbolicExpressionTreeArchitectureManipulator>(
         ga, 50, 1, 50, 0.15, 2);
Index: /stable/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /stable/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 14210)
+++ /stable/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 14211)
@@ -225,4 +225,15 @@
 $SolutionDir/MergeConfigs.sh
 </PostBuildEvent>
-  </PropertyGroup> 
+  </PropertyGroup>
+  <PropertyGroup>
+    <PostBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set OutDir=$(OutDir)
+set TargetDir=$(TargetDir)
+set Platform=$(PlatformName)
+set Configuration=$(ConfigurationName)
+
+call "$(SolutionDir)MergeConfigs.cmd"</PostBuildEvent>
+  </PropertyGroup>
 </Project>
Index: /stable/MergeConfigs.cmd
===================================================================
--- /stable/MergeConfigs.cmd	(revision 14210)
+++ /stable/MergeConfigs.cmd	(revision 14211)
@@ -7,5 +7,5 @@
 
 echo Recreating HeuristicLab 3.3.exe.config...
-copy /Y "%TargetDir%app.config" "%TargetDir%HeuristicLab 3.3.exe.config"
+copy /Y "%SolutionDir%\HeuristicLab\3.3\app.config" "%TargetDir%HeuristicLab 3.3.exe.config"
 
 echo Merging...
Index: /stable/MergeConfigs.sh
===================================================================
--- /stable/MergeConfigs.sh	(revision 14210)
+++ /stable/MergeConfigs.sh	(revision 14211)
@@ -4,5 +4,5 @@
 
 echo Recreating HeuristicLab 3.3.exe.config...
-cp $TargetDir/app.config "$TargetDir/HeuristicLab 3.3.exe.config"
+cp $SolutionDir/HeuristicLab/3.3/app.config "$TargetDir/HeuristicLab 3.3.exe.config"
 
 echo Merging...